import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Point;
import java.awt.Rectangle;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;
import javax.swing.text.DefaultCaret;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.LineNumberInputStream;
import java.io.PrintStream;
import java.net.*;
import java.util.LinkedList;

import javax.swing.JButton;
import javax.swing.JTextField;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JLabel;
import java.awt.Insets;



public class NetSocket extends JFrame {

	Socket Sk=null;
	private JTextArea AllTxt;
	private JTextArea SendTxt;
	private JTextField Address;
	private JTextField Port;
	private JButton btnConnect;
	
	String add="192.168.1.10";
	int port=5000;
	Receive rc=null;
	private JButton btnReset;
	
	LinkedList circbuff;
	
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");}catch (Exception e){};		
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					NetSocket frame = new NetSocket();
					frame.setVisible(true);
					frame.init();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public NetSocket() {
		setTitle("Socket connection");
		setResizable(false);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 599, 451);
		getContentPane().setLayout(null);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(0, 45, 593, 294);
		getContentPane().add(scrollPane);
		
		AllTxt = new JTextArea();
		AllTxt.setEditable(false);
		scrollPane.setViewportView(AllTxt);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(0, 340, 593, 81);
		getContentPane().add(scrollPane_1);
		
		SendTxt = new JTextArea();
		SendTxt.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent arg0) {kreturn(arg0);
			}
		});
		SendTxt.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent arg0) {kreturn2(arg0);
			}
		});
		scrollPane_1.setViewportView(SendTxt);
		
		btnConnect = new JButton("Connect");
		btnConnect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {connect();
			}
		});
		btnConnect.setBounds(12, 10, 99, 25);
		getContentPane().add(btnConnect);
		
		Address = new JTextField();
		Address.setBounds(180, 10, 116, 22);
		getContentPane().add(Address);
		Address.setColumns(10);
		
		Port = new JTextField();
		Port.setBounds(342, 10, 59, 22);
		getContentPane().add(Port);
		Port.setColumns(10);
		
		Address.setText(add);
		Port.setText(String.valueOf(port));
		
		JLabel lblAddress = new JLabel("Address");
		lblAddress.setBounds(122, 14, 56, 16);
		getContentPane().add(lblAddress);
		
		JLabel lblPort = new JLabel("Port");
		lblPort.setBounds(308, 14, 36, 16);
		getContentPane().add(lblPort);
		
		btnReset = new JButton("Clear");
		btnReset.setMargin(new Insets(2, 10, 2, 10));
		btnReset.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {reset();
			}
		});
		btnReset.setBounds(427, 10, 72, 25);
		getContentPane().add(btnReset);
		
		JButton btnNewButton = new JButton("Help");
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {help();
			}
		});
		btnNewButton.setMargin(new Insets(2, 5, 2, 5));
		btnNewButton.setBounds(520, 10, 60, 25);
		getContentPane().add(btnNewButton);
		
		((DefaultCaret)AllTxt.getCaret()).setUpdatePolicy(DefaultCaret.ALWAYS_UPDATE);
		circbuff=new LinkedList();
	}
	
	
	public void init()
	{
		rc=new Receive();
		rc.start();
	}
	
	
	public void help()
	{
		String message=
				"Connect to IP address and port. \n"+
		        "Write a record on lower panel \n(local echo only if connection not established)\n"+
		        "Use up&down arrows to recall previous lines\n"+
          		"Message is sent when you click return\n"+
		        "If you want to split line, you have to use shift+return.";
		JOptionPane.showMessageDialog(this, message);
	}
	
	Color sys=new Color(212,208,200);
	public void connect()
	{
		if (Sk!=null) 
		{try {Sk.close();Sk=null;
		 btnConnect.setBackground(sys);btnConnect.setText("Connect");return;}
		 catch (IOException ex){}}
		add=Address.getText();
		port=Integer.parseInt(Port.getText());
		InetSocketAddress isk=new InetSocketAddress(add,port);
		if (Sk!=null) try {Sk.close();Sk=null;rc.in=null;rc.ou=null;}catch(Exception ex){}
		try{Sk=new Socket();Sk.connect(isk, 5000);}
		catch (Exception ex){err(ex.getMessage());Sk=null;rc.in=null;rc.ou=null;}
		if(Sk!=null) 
		{
			for(int i=0;i<20;i++){if(!Sk.isConnected()) delay(100);else break;}
		    if(Sk.isConnected()) 
		    	{echo("Connected with "+add+" : "+port+" !\n");
		    	 btnConnect.setBackground(Color.green);
		    	 btnConnect.setText("Disconnect");
		    	}
		    else echo("No connection!");
		}
	}
	
	
	public void reset()
	{
		AllTxt.setText("");
	}
	
	public void err(String txt)
	{
		AllTxt.append("ERROR : "+txt+"\n");
	}

	public void echo(String txt)
	{
		AllTxt.append(txt);
	}
	
	public void receive(String txt)
	{
		if (txt==null) return;
		AllTxt.append("> "+txt+"\n");
	}
	
	public void receive(int b)
	{
		if (b<0) return;
		char c=(char)b;if (c=='\r') c='^';
		AllTxt.append(String.valueOf(c));
	}

	
	public void kreturn(KeyEvent ke)
	{
		if (ke.getKeyChar()=='\n')
		{
			if (ke.getModifiers()==1) {SendTxt.append("\n");return;}
			String slast=SendTxt.getText();
			if (rc.ou!=null) rc.ou.print(slast);
			else echo(slast);
		    SendTxt.setText("");
		    if (circbuff.size()>10) circbuff.removeFirst();
		    if (slast.length()>1) 
		    	{slast=slast.substring(0, slast.length()-1);
		         circbuff.add(slast);
		         pos=circbuff.size()-1;}
		}
	}
	
	int pos=0;
	public void kreturn2(KeyEvent ke)
	{
		if (ke.getKeyCode()==KeyEvent.VK_UP)
		{
			String slast=(String)circbuff.get(pos);
			pos--;
			if (pos<0)pos=0; 
			SendTxt.setText(slast);
		}
		if (ke.getKeyCode()==KeyEvent.VK_DOWN)
		{
			String slast=(String)circbuff.get(pos);
			pos++;
			if(pos==circbuff.size())pos=circbuff.size()-1;
			SendTxt.setText(slast);
		}
		
	}
	
	
	class Receive extends Thread
	{
		BufferedReader in=null;
		PrintStream ou=null;
		
		public void run()
		{
			ciclo();
		}
		
		void ciclo()
		{
			while(true)
			{
				if (Sk==null) {delay(100);continue;}
				if (!Sk.isConnected()){delay(100);continue;}
				if (in==null)
				{try{in=new BufferedReader(new InputStreamReader(Sk.getInputStream()));
				 ou=new PrintStream(Sk.getOutputStream());}
				 catch(IOException ex){ex.printStackTrace();}}
				try{String s=in.readLine();receive(s);}catch(IOException ex){}
//				try{int b=in.read();receive(b);}catch(IOException ex){}
			}
		}
		
	}
	
	void delay(int ms)
	{
		try{Thread.sleep(ms);}catch(Exception ex){}
	}
}
