import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;
import java.net.SocketTimeoutException;
import java.sql.Timestamp;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.UIManager;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.SwingConstants;
import javax.swing.text.DefaultCaret;



public class NetSocketLog {
	private JFrame frame;
	
	private JTextArea textArea;
	int port=5000;
	ListenServer LS;
	private JMenuBar menuBar;
	private JMenu mnFile;
	private JMenuItem mntmOpen;
	private JMenuItem mntmClose;
	private JMenu mnPort;
	private JMenuItem mntmPortSelect;
	private JMenu mnShow;

	
	PrintStream pout=null;
	boolean Fvis=true;
	boolean Ftime=true;
	boolean Ftconsole=false;
	Timestamp timestp;
	
	private JCheckBoxMenuItem mTime;
	private JCheckBoxMenuItem mlistvis;
	private JCheckBoxMenuItem mTconsole;
	private JMenuItem mntmNewMenuItem;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");}catch (Exception e){};		
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					NetSocketLog window = new NetSocketLog();
					window.frame.setVisible(true);
					window.LS=window.new ListenServer(window);
					window.LS.start();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public NetSocketLog() {
		initialize();
		long time=System.currentTimeMillis();
		timestp= new Timestamp(time);
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
        
		frame = new JFrame();
		frame.setBounds(100, 100, 608, 593);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(new BorderLayout(0, 0));
		frame.setTitle("Socket Server Port "+port);

		textArea = new JTextArea();
		((DefaultCaret)textArea.getCaret()).setUpdatePolicy(DefaultCaret.ALWAYS_UPDATE);
		textArea.setEditable(false);
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(0, 0, 600, 400);
		scrollPane.setPreferredSize(new Dimension(600,400));
		frame.getContentPane().add(scrollPane);
		scrollPane.setViewportView(textArea);
		
		menuBar = new JMenuBar();
		scrollPane.setColumnHeaderView(menuBar);
		
		mnFile = new JMenu("File");
		menuBar.add(mnFile);
		
		mntmOpen = new JMenuItem("Open...");
		mntmOpen.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {OpenFile();
			}
		});
		mnFile.add(mntmOpen);
		
		mntmClose = new JMenuItem("Close");
		mntmClose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {CloseFile();
			}
		});
		mnFile.add(mntmClose);
		
		mnPort = new JMenu("Port");
		menuBar.add(mnPort);
		
		mntmPortSelect = new JMenuItem("Port select");
		mntmPortSelect.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {PortSelect();
			}
		});
		mnPort.add(mntmPortSelect);
		
		mnShow = new JMenu("Record");
		menuBar.add(mnShow);
		
		mlistvis = new JCheckBoxMenuItem("List on console");
		mlistvis.setSelected(Fvis);
		mlistvis.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {if (Fvis) Fvis=false;
			else Fvis=true ;mlistvis.setSelected(Fvis);}
		});
		mnShow.add(mlistvis);
		
		mTime = new JCheckBoxMenuItem("Timestamp");
		mTime.setSelected(Ftime);
		mTime.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {if (Ftime) Ftime=false;
			else Ftime=true;mTime.setSelected(Ftime);}
		});
		mnShow.add(mTime);
		
		mTconsole = new JCheckBoxMenuItem("Time on console");
		mTconsole.setSelected(Ftconsole);
		mTconsole.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {if (Ftconsole) Ftconsole=false;
			else Ftconsole=true;mTconsole.setSelected(Ftconsole);}
		});
		mnShow.add(mTconsole);
		
		mntmNewMenuItem = new JMenuItem("? ");
		mntmNewMenuItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {help();
			}
		});
		mntmNewMenuItem.setHorizontalAlignment(SwingConstants.CENTER);
		mntmNewMenuItem.setHorizontalTextPosition(SwingConstants.CENTER);
		mntmNewMenuItem.setMaximumSize(new Dimension(32, 32767));
		menuBar.add(mntmNewMenuItem);
		
		frame.pack();
	}
	
    class ListenServer extends Thread
	{
    	NetSocketLog NSSR;
    	ServerSocket Ssk=null;
    	Socket Sk=null;
    	
    	ListenServer(NetSocketLog ls){NSSR=ls;}
    	
    	public void run()
    	{
    		printlnMess("Listening...");
    		cicloServer();
    	}
    	
 		public void cicloServer()
		{
 			
			while(true)
			{
//				if(Sk!=null) {delay(100);continue;}
				if(Ssk==null)
				{try{Ssk=new ServerSocket(port);}catch (Exception ex){ex.printStackTrace();}}
				if(Ssk!=null) 
				{try{Sk=Ssk.accept();
				if (Sk!=null) {NetSocketLog.Server s= NSSR.new Server(Sk);s.start();}
				}
				catch (Exception ex){ex.printStackTrace();}}
			}
		}
	}	
	
    class Server extends Thread
	{
		BufferedReader in=null;
		PrintStream ou=null;
		String mess=null;
		Socket Sk=null;
		boolean frun=true;
		int b;
		
		int mode=-1;
		boolean startMess=false;
		boolean startData=false;
		boolean firstRec=false;
		boolean endMess=false;
		int datalen=0;
		char adata[];
		String sdata=null;
		String url=null;
		String timestr="";
		
		public void run(){ printlnMess("Connect with "+Sk.getInetAddress().toString());ciclo();end();}
		
		Server(Socket Sk){this.Sk=Sk;}
		
		void ciclo()
		{
			while (frun)
			{
				if (Sk==null) {delay(100);continue;}
				if (in==null) 
				{try 
				 {in=new BufferedReader(new InputStreamReader(Sk.getInputStream()));
				  ou=new PrintStream(Sk.getOutputStream());
				 }catch(IOException ex) {ex.printStackTrace();}
				}
				if (in!=null)
				{
					try{mess=in.readLine();}
					catch(SocketException sex){frun=false;printlnMess(sex.getMessage());continue;}
					catch(IOException ex){ex.printStackTrace();}
					if (mess!=null) 
					{
						timestr=timest();
					    printConsole(mess,timestr);
					    printFile(mess,timestr);
					}
					if (mess==null) {frun=false;printlnMess("Socket closed!");}
				}
			}
			try {in.close();ou.close();Sk.close();}
			catch (IOException e) {e.printStackTrace();}
			
		}
		
		void echo(int b)
		{
			if (b<0) return;
			char c=(char)b;
			ou.print(c);
			textArea.append(String.valueOf(c));
		}
		
		void end()
		{
			frun=false;
			try{Sk.close();Sk=null;in=null;}catch(Exception ex){}
//			printlnMess("Thread Closed!\n");
		}
		
	
	}
	
	void printFile(String mess,String tstp)
	{
		if (pout==null) return;
	    if (Ftime) pout.printf("%s %s\r\n", tstp,mess);
	    else pout.println(mess);
	    pout.flush();
	}
	
	void printConsole(String mess,String tstp)
	{
		if (!Fvis) return;
		if (Ftconsole) textArea.append(tstp+" - ");
		textArea.append(mess+"\n");
	}
	
	void printlnMess(String mess)
	{
		textArea.append(timest()+" - ");
		textArea.append(mess+"\n");
	}
	
	
	void delay(int ms)
	{
		try{Thread.sleep(ms);}catch(Exception ex){}
	}

	void PortSelect()
	{
      String sport=JOptionPane.showInputDialog("Port listening", port);
      port=Integer.parseInt(sport);
      if (port==0) port=5000;
      LS= new ListenServer(this);
	  frame.setTitle("Socket Server Port "+port);
	}
	
	void OpenFile()
	{
		String filename=null;
		JFileChooser chooser = new JFileChooser();
	    int returnVal = chooser.showOpenDialog(frame);
	    if(returnVal == JFileChooser.APPROVE_OPTION) 
	    {
	    	try
	    	{filename= chooser.getSelectedFile().getCanonicalPath();
	         pout=new PrintStream(filename);}
	        catch (Exception e) {e.printStackTrace();}
	    }
	}
	
	void CloseFile()
	{
		if (pout!=null)	pout.close();
		pout=null;
	}
	
	String timest()
	{
		long time=System.currentTimeMillis();
		timestp.setTime(time);
		String tstp=timestp.toString();
		int p=tstp.lastIndexOf('.');
		String ts;if (p>-1) ts=tstp.substring(0,p);else ts=tstp;
		return ts;
		
	}
	
	public void help()
	{
		String message=
				"Application receives records from remote ctient on port "+port+",\n"+
		        "writes records on file open and display on console if option selected.\n"+
          		"It add a timestamp (prefix) if option selected (default).\n"+
		        "Timestamp is displayed also in console only if required.\n"+
          		"Records are strings terminated by linefeed or cariagereturn+linefeed";
		JOptionPane.showMessageDialog(frame, message);
	}
	
	

}
